LISTING 2.  The Lookup_Select() and Lookup_Edit() Procedures.

  1  Proc Lookup_Select(edit_is_allowed)
  2  
  3  Private p1,p2,x     ;prompt lines and keystroke character
  4  
  5  ;  Press [F1] and see if it places us into lookup-help
  6  
  7  Help                                      ;press [F1]
  8  If helpmode()<>"LookupHelp" then          ;no, it's not lookup help
  9     If helpmode()="Help" then Esc Endif    ;it's regular help; escape from it
 10     Beep Return "[F1] is not available for this field."  ;can't press [F1]
 11  Endif
 12  
 13  ;  Set up the lookup-help environment
 14  
 15  p1 = "Move to the record you want to select"
 16  If edit_is_allowed then
 17     p2 = "Press [F2] to select the record; [Esc] to cancel; [F9] to edit"
 18  Else 
 19     p2 = "Press [F2] to select the record; [Esc] to cancel"
 20  Endif
 21  Prompt p1,p2
 22  Echo Normal
 23  
 24  ;  Let the user press keys until pressing one which exits from lookup-help
 25  
 26  While helpmode()<>"None"               ;while still in look-up help
 27     x = getchar()                       ;let the user press a key
 28     Switch
 29        Case x=15 or x=-24 or x=-59:     ;[Ctrl-O], [Alt-O], [F1] are illegal
 30           Beep                          ;... so ignore them
 31        Case x=-67 and edit_is_allowed:  ;[F9] to edit the lookup table
 32           Lookup_Edit()                 ;edit the lookup table         
 33           Prompt p1,p2
 34        Case x=-67:       Beep           ;[F9] when it's not allowed
 35        Otherwise:        KeyPress x     ;perform it
 36     EndSwitch
 37  EndWhile
 38  
 39  ;  All done
 40  
 41  Echo Off
 42  Prompt
 43  Return ""
 44  
 45  EndProc
 46  
 47  ;  ------------------------------------------------------------------
 48  
 49  Proc Lookup_Edit()
 50  
 51  Private lut, lutkey, origt
 52  
 53  ;  Remember the current location of the cursor within the lookup table
 54  
 55  Echo Off                   ;don't show the user what's going on
 56  lut = upper(table())       ;get the lookup-table name
 57  CtrlHome Right             ;move to the key field column
 58  lutkey = []                ;remember the current key value
 59  
 60  ;  Switch from lookup mode to the lookup table's image
 61  
 62  Esc                           ;escape from lookup-help
 63  origt = table()               ;get the original table name
 64  MoveTo lut                    ;switch to the lookup table image
 65  
 66  ;  Let the user edit the lookup table
 67  
 68  CtrlHome Right                ;move to the key field column
 69  Locate lutkey                 ;move to the same record
 70  Prompt "Edit the "+lut+" lookup table","Press [F2] when done"
 71  Wait Table Until "F2"
 72  CtrlHome Right                ;move to the key field column
 73  lutkey = []                   ;remember the current key value
 74  
 75  ;  Return to the original table, and resume lookup-help
 76  
 77  MoveTo origt                  ;return to the original table
 78  FormKey                       ;return to the form
 79  Help                          ;return to lookup-help
 80  Locate lutkey              ;return to the original record
 81  Echo Normal                   ;resume echoing
 82  
 83  EndProc

